/*
    Programiranje(C) - 29. rujna 2003. [Matko Botincan]
    -----
    4. zadatak
*/

#include <stdio.h>

typedef struct _cvor {
    int broj;
    struct _cvor *next;
} cvor;

int je_kvadrat(int n) {
    int i;
    for(i=1; i<=n; i++)
        if(i*i==n)
            return 1;
    return 0;
}

cvor* kvadrati(cvor* glava) {
    cvor *prethodni, *trenutni, *temp;

    while(glava!=NULL && je_kvadrat(glava->broj)) {
        trenutni=glava;
        glava=glava->next;
        free(trenutni);
    }

    if(glava==NULL)
        return glava;

    prethodni=glava;
    trenutni=glava->next;
    while(trenutni!=NULL) {
        if(je_kvadrat(trenutni->broj)) {
            prethodni->next=trenutni->next;
            free(trenutni);
            trenutni=prethodni->next;
        }
        else {
            prethodni=trenutni;
            trenutni=prethodni->next;
        }
    }

    return glava;
}

int main() {
    cvor *glava=NULL, *pomocni;
    int foo;
    
    while(1) {
        printf ("Unesi prirodan broj (-1 za kraj): ");
        scanf ("%d", &foo);
        if(foo==-1)
            break;
        pomocni=malloc(sizeof(cvor));
        pomocni->broj=foo;
        pomocni->next=glava;
        glava=pomocni;
    }

    glava=kvadrati(glava);

    printf("\nIspis liste (bez kvadrata prirodnih brojeva): ");
    for(pomocni=glava; pomocni!=NULL; pomocni=pomocni->next)
        printf("%d ", pomocni->broj);
    printf("\n");

    while(glava!=NULL) {
        pomocni=glava;
        glava=glava->next;
        free(pomocni);
    }

    return 0;
}

