/*
    Programiranje(C) - 29. rujna 2003. [Matko Botincan]
    -----
    5. zadatak
*/

#include <stdio.h>

void check(void* p) {
    if(p == NULL) {
        printf("Greska u alokaciji memorije!\n");
        exit(1);
    }   
}

void unos(int** A, int n) {
    int i, j;
    for(i=0; i<n; i++)
        for(j=0; j<n; j++) {
            printf("A[%d][%d]=", i, j);
            scanf("%d", &A[i][j]);
        }
}

void mat(int** A, int n) {
    int i, j, s=0, max=0, index;
    float avg;

    for(i=0; i<n; i++)
        for(j=0; j<n; j++)
            s+=A[i][j];
    avg=(float)s/(n*n);

    for(i=0; i<n; i++) {
        int br=0;
        for(j=0; j<n; j++)
            if(A[i][j]>=avg)
                br++;
        if(br>max) {
            max=br;
            index=i;
        }
    }
    printf("%d. redak.\n", index);
}

int main() {
    int n, i;
    int** A;
    
    printf("Unesite red matrice A: ");
    scanf("%d", &n);

    A=(int**)malloc(n*sizeof(int*));
    check(A);
    for(i=0; i<n; i++) {
        A[i]=(int*)malloc(n*sizeof(int));
        check(A[i]);
    }
    printf("\n");
    unos(A, n);
    printf("\n");

    mat(A, n);

    for(i=0; i<n; i++)
        free(A[i]);
    free(A);
    
    return 0;
}

